Index: /trunk/Assembly_Library/Src/Menu/Dialog/DialogFile.asm
===================================================================
--- /trunk/Assembly_Library/Src/Menu/Dialog/DialogFile.asm	(revision 591)
+++ /trunk/Assembly_Library/Src/Menu/Dialog/DialogFile.asm	(revision 592)
@@ -249,6 +249,11 @@
 ALIGN JUMP_ALIGN
 AppendFileFromDTAinDSSItoOffScreenBuffer:
-	call	.FilterCurrentDirectory			; We never want "."
-	call	.FilterUpDirectoryWhenInRoot	; No ".." when in root directory
+	cmp		WORD [si+DTA.szFile], CURRENTDIR_CHARACTERS
+	je		SHORT .Return					; We never want "."
+	test	dl, dl
+	jnz		SHORT .NotInRootDirectory
+	cmp		WORD [si+DTA.szFile], UPDIR_CHARACTERS
+	je		SHORT .Return					; No ".." when in root directory
+.NotInRootDirectory:
 	inc		cx								; Nothing filtered so increment files/directories
 
@@ -262,34 +267,5 @@
 	pop		si
 	pop		bp
-	ret
-
-;--------------------------------------------------------------------
-; .FilterCurrentDirectory
-; .FilterUpDirectoryWhenInRoot
-;	Parameters:
-;		DL:		Zero if root directory selected
-;		DS:SI:	Ptr to DTA containing file information
-;	Returns:
-;		Nothing
-;		Returns from AppendFileToBufferInESDIfromDtaInDSSI when filtering
-;	Corrupts registers:
-;		AX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-.FilterCurrentDirectory:
-	cmp		WORD [si+DTA.szFile], CURRENTDIR_CHARACTERS
-	je		SHORT .DoFilter
-	ret
-
-ALIGN JUMP_ALIGN
-.FilterUpDirectoryWhenInRoot:
-	test	dl, dl			; Set ZF if root directory selected
-	jnz		SHORT .ReturnWithoutFiltering
-	cmp		WORD [si+DTA.szFile], UPDIR_CHARACTERS
-	jne		SHORT .ReturnWithoutFiltering
-.DoFilter:
-	add		sp, BYTE 2		; Remove return address from stack
-ALIGN JUMP_ALIGN, ret
-.ReturnWithoutFiltering:
+.Return:
 	ret
 
@@ -473,7 +449,7 @@
 ALIGN JUMP_ALIGN
 GetInfoLinesToCXandDialogFlagsToAX:
-	xor		ax, ax
-	call	GetDialogFlagsToAL
-	jmp		Bit_GetSetCountToCXfromAX
+	ePUSH_T	ax, Bit_GetSetCountToCXfromAX
+	xor		ah, ah
+	; Fall to GetDialogFlagsToAL
 
 ;--------------------------------------------------------------------
@@ -696,4 +672,5 @@
 	call	.ChangeDriveToUserSelectionFromIoInDSSI
 	add		sp, BYTE DRIVE_DIALOG_IO_size
+.UserCancelledDriveChange:
 	ret
 
@@ -729,9 +706,48 @@
 	jne		SHORT .UserCancelledDriveChange
 
+	; Install our Custom Critical Error Handler to catch "Drive Not Ready" errors. This handler only works on DOS 3.0+ systems
+	; but that should be OK because only DOS 3.1+ will trigger it. Under older DOS versions drives are enumerated using
+	; GET_DOS_DRIVE_PARAMETER_BLOCK_FOR_SPECIFIC_DRIVE which will access the drive so we know it is available at this point.
+	mov		dx, DosCritical_CustomHandler
+	call	DosCritical_InstallNewHandlerFromCSDX
+
+	; Save the current drive on stack in case the selected drive is not ready and the user decides to cancel the change.
+	call	Drive_GetDefaultToAL
+	xchg	dx, ax
+
+.RetryDrive:
+	push	dx									; Save the previous current drive to stack
+
 	mov		dl, [si+DRIVE_DIALOG_IO.bReturnDriveNumber]
 	call	Drive_SetDefaultFromDL
+
+	; Now we must try to force a media access to catch "Drive Not Ready".
+	push	ds
+	push	ss
+	pop		ds
+	ePUSH_T	ax, CURRENTDIR_CHARACTERS
+	mov		cx, FLG_FILEATTR_DIRECTORY
+	mov		dx, sp
+	mov		ax, FIND_FIRST_MATCHING_FILE<<8
+	int		DOS_INTERRUPT_21h
+	pop		ax
+	pop		ds
+
+	pop		dx									; Restore the previous current drive from stack
+
+	xchg	ah, [cs:bLastCriticalError]			; Zero bLastCriticalError and fetch error code to AH
+	cmp		ah, ERR_DOS_DRIVE_NOT_READY
+	jne		SHORT .DriveIsReady
+
+	mov		bx, g_szDlgDriveNotReady
+	call	Dialogs_DisplayYesNoResponseDialogWithTitleStringInBX
+	jz		SHORT .RetryDrive
+	; The user cancelled the drive change. Restore current drive to what it was previously.
+	call	Drive_SetDefaultFromDL
+	jmp		DosCritical_RestoreDosHandler
+
+.DriveIsReady:
+	call	DosCritical_RestoreDosHandler
 	jmp		RefreshFilesToDisplay
-.UserCancelledDriveChange:
-	ret
 
 
Index: /trunk/Assembly_Library/Src/Menu/MenuAttributes.asm
===================================================================
--- /trunk/Assembly_Library/Src/Menu/MenuAttributes.asm	(revision 591)
+++ /trunk/Assembly_Library/Src/Menu/MenuAttributes.asm	(revision 592)
@@ -91,4 +91,5 @@
 
 .rgcColorAttributes:
+; Classic (default theme)
 istruc ATTRIBUTE_CHARS
 	at	ATTRIBUTE_CHARS.cBordersAndBackground,	db	COLOR_ATTRIBUTE(COLOR_YELLOW, COLOR_BLUE)
@@ -100,4 +101,5 @@
 	at	ATTRIBUTE_CHARS.cNormalTimeout,			db	COLOR_ATTRIBUTE(COLOR_GREEN, COLOR_BLUE)
 iend
+ColorTheme	equ		MenuAttribute_GetToAXfromTypeInSI.rgcColorAttributes
 
 .rgcBlackAndWhiteAttributes:	; Only COLOR_WHITE, COLOR_BRIGHT_WHITE and COLOR_BLACK should be used
Index: /trunk/Assembly_Library/Src/Menu/MenuBorders.asm
===================================================================
--- /trunk/Assembly_Library/Src/Menu/MenuBorders.asm	(revision 591)
+++ /trunk/Assembly_Library/Src/Menu/MenuBorders.asm	(revision 592)
@@ -87,5 +87,5 @@
 ;		AX, BX, CX, DX, SI, DI
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB OR EXCLUDE_FROM_XTIDECFG
 ALIGN MENU_JUMP_ALIGN
 MenuBorders_RefreshItemBorders:
Index: /trunk/Assembly_Library/Src/Menu/MenuInit.asm
===================================================================
--- /trunk/Assembly_Library/Src/Menu/MenuInit.asm	(revision 591)
+++ /trunk/Assembly_Library/Src/Menu/MenuInit.asm	(revision 592)
@@ -114,5 +114,5 @@
 ;		AX, BX, DX
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB
 ALIGN MENU_JUMP_ALIGN
 MenuInit_CloseMenuIfExitEventAllows:
@@ -138,5 +138,5 @@
 
 
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB
 ;--------------------------------------------------------------------
 ; MenuInit_HighlightItemFromAX
@@ -168,5 +168,5 @@
 	mov		ax, [bp+MENUINIT.wHighlightedItem]
 	ret
-%endif ; EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%endif ; EXCLUDE_FROM_XUB
 
 
@@ -183,5 +183,6 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB
+%ifndef EXCLUDE_FROM_XTIDECFG
 ALIGN MENU_JUMP_ALIGN
 MenuInit_SetTitleHeightFromAL:
@@ -193,4 +194,5 @@
 	mov		[bp+MENUINIT.bInfoLines], al
 	ret
+%endif ; EXCLUDE_FROM_XTIDECFG
 
 ALIGN MENU_JUMP_ALIGN
@@ -198,5 +200,5 @@
 	mov		[bp+MENUINIT.wItems], ax
 	ret
-%endif
+%endif ; EXCLUDE_FROM_XUB
 
 
@@ -212,5 +214,6 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB
+%ifndef EXCLUDE_FROM_XTIDECFG
 ALIGN MENU_JUMP_ALIGN
 MenuInit_SetUserDataFromDSSI:
@@ -218,4 +221,5 @@
 	mov		[bp+MENU.dwUserData+2], ds
 	ret
+%endif ; EXCLUDE_FROM_XTIDECFG
 
 ALIGN MENU_JUMP_ALIGN
@@ -223,3 +227,3 @@
 	lds		si, [bp+MENU.dwUserData]
 	ret
-%endif
+%endif ; EXCLUDE_FROM_XUB
Index: /trunk/Assembly_Library/Src/Menu/MenuLocation.asm
===================================================================
--- /trunk/Assembly_Library/Src/Menu/MenuLocation.asm	(revision 591)
+++ /trunk/Assembly_Library/Src/Menu/MenuLocation.asm	(revision 592)
@@ -55,5 +55,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB
 MenuLocation_GetItemBordersTopLeftCoordinatesToAX:
 %endif
Index: /trunk/Assembly_Library/Src/Menu/MenuText.asm
===================================================================
--- /trunk/Assembly_Library/Src/Menu/MenuText.asm	(revision 591)
+++ /trunk/Assembly_Library/Src/Menu/MenuText.asm	(revision 592)
@@ -32,5 +32,5 @@
 ;		AX, BX, CX, DX, SI, DI
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB OR EXCLUDE_FROM_XTIDECFG
 ALIGN MENU_JUMP_ALIGN
 MenuText_ClearTitleArea:
Index: /trunk/Assembly_Library/Src/Serial/SerialServer.asm
===================================================================
--- /trunk/Assembly_Library/Src/Serial/SerialServer.asm	(revision 591)
+++ /trunk/Assembly_Library/Src/Serial/SerialServer.asm	(revision 592)
@@ -61,6 +61,8 @@
 		push	ax				; working copy on the top of the stack
 
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS	; DF already cleared in Int13h.asm
+%ifndef EXCLUDE_FROM_XUB		; DF already cleared in Int13h.asm
+%ifdef CLD_NEEDED
 		cld
+%endif
 %endif
 
Index: /trunk/Assembly_Library/Src/String/Char.asm
===================================================================
--- /trunk/Assembly_Library/Src/String/Char.asm	(revision 591)
+++ /trunk/Assembly_Library/Src/String/Char.asm	(revision 592)
@@ -51,5 +51,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifdef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifdef EXCLUDE_FROM_XUB
 	%ifndef MODULE_HOTKEYS
 		%define EXCLUDE
@@ -57,5 +57,5 @@
 %endif
 
-%ifndef EXCLUDE
+%ifndef EXCLUDE OR EXCLUDE_FROM_BIOSDRVS
 ALIGN STRING_JUMP_ALIGN
 Char_IsLowerCaseLetterInAL:
@@ -76,5 +76,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB OR EXCLUDE_FROM_BIOSDRVS
 ALIGN STRING_JUMP_ALIGN
 Char_IsUpperCaseLetterInAL:
@@ -95,5 +95,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB OR EXCLUDE_FROM_BIOSDRVS
 ALIGN STRING_JUMP_ALIGN
 Char_IsHexadecimalDigitInAL:
@@ -136,5 +136,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB OR EXCLUDE_FROM_BIOSDRVS
 ALIGN STRING_JUMP_ALIGN
 Char_ConvertIntegerToALfromDigitInALwithBaseInBX:
@@ -166,5 +166,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB OR EXCLUDE_FROM_BIOSDRVS
 ALIGN STRING_JUMP_ALIGN
 Char_CharIsValid:
@@ -174,5 +174,5 @@
 
 
-%ifdef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifdef EXCLUDE_FROM_XUB
 	%ifndef MODULE_HOTKEYS
 		%define EXCLUDE
@@ -201,5 +201,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB OR EXCLUDE_FROM_BIOSDRVS
 ALIGN STRING_JUMP_ALIGN
 Char_ALtoLowerCaseLetter:
@@ -218,5 +218,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB OR EXCLUDE_FROM_BIOSDRVS
 ALIGN STRING_JUMP_ALIGN
 Char_ALtoUpperCaseLetter:
@@ -237,5 +237,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB OR EXCLUDE_FROM_BIOSDRVS
 Char_ChangeCaseInAL:
 	xor		al, 32
@@ -254,5 +254,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB OR EXCLUDE_FROM_BIOSDRVS
 ALIGN STRING_JUMP_ALIGN
 Char_GetFilterFunctionToDXforNumericBaseInBX:
Index: /trunk/Assembly_Library/Src/Time/TimerTicks.asm
===================================================================
--- /trunk/Assembly_Library/Src/Time/TimerTicks.asm	(revision 591)
+++ /trunk/Assembly_Library/Src/Time/TimerTicks.asm	(revision 592)
@@ -48,5 +48,5 @@
 ;		CX
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB
 %ifndef EXCLUDE_FROM_XTIDECFG
 ALIGN JUMP_ALIGN
@@ -64,7 +64,7 @@
 	div		cx		; Divide DX:AX by CX, Minutes to AX, remainder ticks to DX
 	ret
-%endif ; EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
-
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS OR EXCLUDE_FROM_XTIDECFG
+%endif ; EXCLUDE_FROM_XUB
+
+%ifndef EXCLUDE_FROM_XUB OR EXCLUDE_FROM_XTIDECFG
 ALIGN JUMP_ALIGN
 TimerTicks_GetSecondsToAXandRemainderTicksToDXfromTicksInDX:
@@ -80,5 +80,5 @@
 
 
-%ifdef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifdef EXCLUDE_FROM_XUB
 	%ifndef MODULE_BOOT_MENU
 		%define EXCLUDE
@@ -164,5 +164,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB OR EXCLUDE_FROM_XTIDECFG
 ALIGN JUMP_ALIGN
 TimerTicks_GetElapsedToAXandResetDSBX:
@@ -184,5 +184,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB OR EXCLUDE_FROM_XTIDECFG
 ALIGN JUMP_ALIGN
 TimerTicks_GetElapsedToAXfromDSBX:
@@ -202,5 +202,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifdef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifdef EXCLUDE_FROM_XUB
 	%ifndef MODULE_BOOT_MENU OR MODULE_HOTKEYS
 		%define EXCLUDE
Index: /trunk/Assembly_Library/Src/Util/Bit.asm
===================================================================
--- /trunk/Assembly_Library/Src/Util/Bit.asm	(revision 591)
+++ /trunk/Assembly_Library/Src/Util/Bit.asm	(revision 592)
@@ -24,5 +24,5 @@
 ; Bit_GetSetCountToCXfromDXAX
 ;	Parameters
-;		DX:AX:		Source DWORD
+;		DX:AX:	Source DWORD
 ;	Returns:
 ;		CX:		Number of bits set in DX:AX
@@ -58,14 +58,12 @@
 	push	ax
 
-	xor		cx, cx
+	mov		cx, -1
 ALIGN JUMP_ALIGN
-.BitScanLoop:
+.IncrementCX:
+	inc		cx
+.ShiftLoop:
 	shr		ax, 1
-	jz		SHORT .LastBitInCF
-	adc		cl, ch
-	jmp		SHORT .BitScanLoop
-ALIGN JUMP_ALIGN
-.LastBitInCF:
-	adc		cl, ch
+	jc		SHORT .IncrementCX
+	jnz		SHORT .ShiftLoop
 
 	pop		ax
@@ -95,4 +93,5 @@
 	ret
 
+
 ;--------------------------------------------------------------------
 ; Bit_SetToAXfromIndexInCL
@@ -115,2 +114,3 @@
 	pop		dx
 	ret
+
Index: /trunk/Assembly_Library/Src/Util/Math.asm
===================================================================
--- /trunk/Assembly_Library/Src/Util/Math.asm	(revision 591)
+++ /trunk/Assembly_Library/Src/Util/Math.asm	(revision 592)
@@ -33,27 +33,7 @@
 ;		AX
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS OR EXCLUDE_FROM_XTIDECFG
+%ifndef EXCLUDE_FROM_XTIDECFG
 ALIGN JUMP_ALIGN
 Math_DivQWatSSBPbyCX:
-%if 1
-	xor		dx, dx
-	mov		ax, [bp+6]		; Load highest divident WORD to DX:AX
-	div		cx
-	mov		[bp+6], ax		; Store quotient
-
-	mov		ax, [bp+4]
-	div		cx
-	mov		[bp+4], ax
-
-	mov		ax, [bp+2]
-	div		cx
-	mov		[bp+2], ax
-
-	mov		ax, [bp]
-	div		cx
-	mov		[bp], ax
-	ret
-%else ; ~1
-; This is about half the size compared to the above code but it's not tested which is why it's commented away.
 	push	di
 	mov		di, 6
@@ -65,8 +45,7 @@
 	dec		di
 	dec		di
-	jns		.Next
+	jns		SHORT .Next
 	pop		di
 	ret
-%endif ; 1
 %endif
 
@@ -83,5 +62,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDECFG
+%ifndef EXCLUDE_FROM_XTIDECFG OR EXCLUDE_FROM_BIOSDRVS
 ALIGN JUMP_ALIGN
 Math_DivDXAXbyCX:
Index: /trunk/Assembly_Library/Src/Util/Memory.asm
===================================================================
--- /trunk/Assembly_Library/Src/Util/Memory.asm	(revision 591)
+++ /trunk/Assembly_Library/Src/Util/Memory.asm	(revision 592)
@@ -24,27 +24,20 @@
 ; OPTIMIZE_STRING_OPERATION
 ;	Parameters
-;		%1:		Repeat instruction
-;		%2:		String instruction without size (for example MOVS and not MOVSB or MOVSW)
+;		%1:		String instruction without size (only MOVS and STOS is supported)
 ;		CX:		Number of BYTEs to operate
-;		DS:SI:	Ptr to source data
+;		DS:SI:	Ptr to source data (for MOVS)
 ;		ES:DI:	Ptr to destination
 ;	Returns:
+;		CF:		Cleared
+;		CX:		Zero
 ;		SI, DI:	Updated by number of bytes operated
 ;	Corrupts registers:
 ;		Nothing
 ;--------------------------------------------------------------------
-%macro OPTIMIZE_STRING_OPERATION 2
-	push	cx
-
-	shr		cx, 1			; Operate with WORDs for performance
-	jz	%%HandleRemainingByte
-	%1		%2w
-%%HandleRemainingByte:
-	jnc		SHORT %%OperationCompleted
-	%2b
-
-ALIGN JUMP_ALIGN
-%%OperationCompleted:
-	pop		cx
+%macro OPTIMIZE_STRING_OPERATION 1
+	shr		cx, 1
+	rep		%1w
+	eRCL_IM	cx, 1
+	rep		%1b
 %endmacro
 
@@ -57,12 +50,15 @@
 ;		ES:DI:	Ptr to destination buffer
 ;	Returns:
+;		CF:		Cleared
 ;		SI, DI:	Updated by number of bytes copied
 ;	Corrupts registers:
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB
 ALIGN JUMP_ALIGN
 Memory_CopyCXbytesFromDSSItoESDI:
-	OPTIMIZE_STRING_OPERATION rep, movs
+	push	cx
+	OPTIMIZE_STRING_OPERATION movs
+	pop		cx
 	ret
 %endif
@@ -77,5 +73,5 @@
 ;		Nothing
 ;	Corrupts registers:
-;		Nothing
+;		CX
 ;--------------------------------------------------------------------
 %ifdef INCLUDE_MENU_LIBRARY
@@ -102,5 +98,5 @@
 ;		DI:		Updated by number of BYTEs stored
 ;	Corrupts registers:
-;		AX
+;		AX, CX
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
@@ -118,9 +114,8 @@
 ;		DI:		Updated by number of BYTEs stored
 ;	Corrupts registers:
-;		Nothing
+;		CX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
 Memory_StoreCXbytesFromAccumToESDI:
-	OPTIMIZE_STRING_OPERATION rep, stos
+	OPTIMIZE_STRING_OPERATION stos
 	ret
 
@@ -135,5 +130,5 @@
 ;		AX
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB
 ALIGN JUMP_ALIGN
 Memory_ReserveCXbytesFromStackToDSSI:
Index: /trunk/Assembly_Library/Src/Util/Reboot.asm
===================================================================
--- /trunk/Assembly_Library/Src/Util/Reboot.asm	(revision 591)
+++ /trunk/Assembly_Library/Src/Util/Reboot.asm	(revision 592)
@@ -44,5 +44,5 @@
 	mov		al, 0FEh				; System reset (AT+ keyboard controller)
 	out		64h, al					; Reset computer (AT+)
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB
 	%ifdef INCLUDE_TIME_LIBRARY
 		mov		ax, 10
Index: /trunk/Assembly_Library/Src/Util/Registers.asm
===================================================================
--- /trunk/Assembly_Library/Src/Util/Registers.asm	(revision 591)
+++ /trunk/Assembly_Library/Src/Util/Registers.asm	(revision 592)
@@ -59,5 +59,5 @@
 %endif
 
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifndef EXCLUDE_FROM_XUB
 ALIGN JUMP_ALIGN
 Registers_CopySSBPtoDSSI:
@@ -91,15 +91,15 @@
 ;
 ;--------------------------------------------------------------------
-%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS OR EXCLUDE_FROM_XTIDECFG
+%ifndef EXCLUDE_FROM_XUB OR EXCLUDE_FROM_XTIDECFG
 ALIGN JUMP_ALIGN
 Registers_NormalizeESSI:
 	mov			cx, si
-	and			si, byte 0fh
-	jmp			Registers_NormalizeFinish
+	and			si, BYTE 0Fh
+	jmp			SHORT Registers_NormalizeFinish
 
 ALIGN JUMP_ALIGN
 Registers_NormalizeESDI:
 	mov			cx, di
-	and			di, byte 0fh
+	and			di, BYTE 0Fh
 ;;; fall-through
 
Index: /trunk/Assembly_Library/Src/Util/Size.asm
===================================================================
--- /trunk/Assembly_Library/Src/Util/Size.asm	(revision 591)
+++ /trunk/Assembly_Library/Src/Util/Size.asm	(revision 592)
@@ -70,22 +70,15 @@
 	jae		SHORT Size_DivideSizeInBXDXAXby1024andIncrementMagnitudeInCX
 	add		sp, BYTE 2					; Clean return address from stack
-	xchg	si, cx						; CX = Remainder (0...1023), SI = Magnitude
 
 	; Convert remainder to tenths
-	xchg	bx, ax						; Store AX
-	mov		al, 5						; AH = 0
-	mul		cx							; DX:AX = remainder * (10 / 2)
-%ifdef USE_186
-	shr		ax, 9						; Divide AX by (1024 / 2)
-%else
-	shr		ax, 1
-	mov		al, ah
-	cbw
-%endif
-	xchg	cx, ax						; CX = tenths
-	xchg	ax, bx
+	mov		bx, 640
+	xchg	bx, ax						; BX = Size, AX = (10 / 1024) * 65536
+	mul		si							; DX = Remainder * (10 / 1024)
+	xchg	dx, ax
+	xchg	cx, ax						; CX = Tenths, AX = Magnitude
+	xchg	bx, ax						; AX = Size, BX	= Magnitude
 
 	; Convert magnitude to character
-	mov		dl, [cs:si+.rgbMagnitudeToChar]
+	mov		dl, [cs:bx+.rgbMagnitudeToChar]
 
 	pop		si
@@ -154,5 +147,5 @@
 ;		Nothing
 ;--------------------------------------------------------------------
-%ifdef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
+%ifdef EXCLUDE_FROM_XUB
 	%ifdef USE_386
 		%define EXCLUDE
Index: /trunk/Assembly_Library/Src/Util/Sort.asm
===================================================================
--- /trunk/Assembly_Library/Src/Util/Sort.asm	(revision 591)
+++ /trunk/Assembly_Library/Src/Util/Sort.asm	(revision 592)
@@ -63,5 +63,7 @@
 	push	cx
 
+%ifdef CLD_NEEDED
 	cld
+%endif
 	mov		cx, di						; Restore item size to CX
 	xor		ax, ax						; Zero starting index
@@ -191,5 +193,5 @@
 
 	cmp		ax, dx	; If (left <= right)
-	jg		SHORT ArrangeItemsInRangeAXtoDXtoBothSidesOfPivotInESDI
+	jg		SHORT .BreakLoopSinceAllItemsExamined
 	call	SwapItemsFromIndexesAXandDX
 	inc		ax
Index: /trunk/BIOS_Drive_Information_Tool/Src/Print.asm
===================================================================
--- /trunk/BIOS_Drive_Information_Tool/Src/Print.asm	(revision 591)
+++ /trunk/BIOS_Drive_Information_Tool/Src/Print.asm	(revision 592)
@@ -149,5 +149,5 @@
 	xor		dh, dh
 	mov		si, dx
-	shl		si, 1		; Shift for WORD lookup
+	eSHL_IM	si, 1		; Shift for WORD lookup
 	push	WORD [si+.rgszXlateModeToString]
 
@@ -197,6 +197,10 @@
 ;--------------------------------------------------------------------
 Print_NameFromAtaInfoInBX:
+%ifdef CLD_NEEDED
 	cld
+%endif
+	mov		bp, sp
 	lea		si, [bx+ATA1.strModel]
+	push	si
 	mov		di, si
 	mov		cx, A1_MODEL_NUMBER_LENGTH/2
@@ -211,7 +215,4 @@
 	stosb				; Terminate with NULL
 
-	mov		bp, sp
-	lea		si, [bx+ATA1.strModel]
-	push	si
 	mov		si, g_szFormatDrvName
 	jmp		SHORT JumpToFormatNullTerminatedStringFromSI
Index: /trunk/BIOS_Drive_Information_Tool/Src/Strings.asm
===================================================================
--- /trunk/BIOS_Drive_Information_Tool/Src/Strings.asm	(revision 591)
+++ /trunk/BIOS_Drive_Information_Tool/Src/Strings.asm	(revision 592)
@@ -21,6 +21,6 @@
 SECTION .data
 
-g_szProgramName:	db	"BIOS Drive Information Tool v1.0.2",CR,LF
-					db	"(C) 2012-2016 by XTIDE Universal BIOS Team",CR,LF
+g_szProgramName:	db	"BIOS Drive Information Tool v1.0.3",CR,LF
+					db	"(C) 2012-2018 by XTIDE Universal BIOS Team",CR,LF
 					db	"Released under GNU GPL v2",CR,LF
 					db	"http://xtideuniversalbios.org/",CR,LF,NULL
@@ -42,6 +42,6 @@
 g_szBlockMode:		db	" Block mode   : Set to %u from max %u sectors",CR,LF,NULL
 g_szPIO:			db	" PIO mode     : Max %u, Min cycle times: %u ns, with IORDY %d ns",CR,LF,NULL
-g_szXTUB:			db	"XTIDE Universal BIOS %s generates following L-CHS...",CR,LF,NULL
-g_szXTUBversion:	db	ROM_VERSION_STRING	; This one is NULL terminated
+g_szXUB:			db	"XTIDE Universal BIOS %s generates following L-CHS...",CR,LF,NULL
+g_szXUBversion:		db	ROM_VERSION_STRING	; This one is NULL terminated
 
 g_szOldInfoHeader:	db	"Old INT 13h information from AH=08h and AH=15h...",CR,LF,NULL
Index: /trunk/BIOS_Drive_Information_Tool/makefile
===================================================================
--- /trunk/BIOS_Drive_Information_Tool/makefile	(revision 591)
+++ /trunk/BIOS_Drive_Information_Tool/makefile	(revision 592)
@@ -52,5 +52,5 @@
 # Assembler preprocessor defines.                               #
 #################################################################
-DEFINES = 
+DEFINES = EXCLUDE_FROM_BIOSDRVS
 DEFINES_XT = ELIMINATE_CGA_SNOW
 DEFINES_XTPLUS = USE_186 ELIMINATE_CGA_SNOW
@@ -98,5 +98,5 @@
 ASFLAGS += $(IHEADERS)			# Set header file directory paths
 ASFLAGS += -Worphan-labels		# Warn about labels without colon
-ASFLAGS += -O9					# Optimize operands to their shortest forms
+ASFLAGS += -Ox					# Optimize operands to their shortest forms
 
 
@@ -130,2 +130,7 @@
 	@upx -qq --8086 --ultra-brute $(TARGET).$(EXTENSION)
 	@echo Done! XT version is ready for release.
+
+xt_unused: xt
+	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_XT) -o"$(TARGET)_xt_unused.asm" -E -DCHECK_FOR_UNUSED_ENTRYPOINTS
+	@perl ..\Tools\unused.pl $(TARGET)_xt.lst $(TARGET)_xt_unused.asm
+
Index: /trunk/Serial_Server/library/Checksum.cpp
===================================================================
--- /trunk/Serial_Server/library/Checksum.cpp	(revision 591)
+++ /trunk/Serial_Server/library/Checksum.cpp	(revision 592)
@@ -343,5 +343,5 @@
 			}
 
-			bbuff[ rand() % 512 ] ^= bit[ rand() % 8 ];
+			bbuff[ rand() & 511 ] ^= bit[ rand() & 7 ];
 
 			if( b > 0 )
Index: /trunk/Serial_Server/library/Image.cpp
===================================================================
--- /trunk/Serial_Server/library/Image.cpp	(revision 591)
+++ /trunk/Serial_Server/library/Image.cpp	(revision 592)
@@ -131,5 +131,5 @@
 			sect = 63;
 		}
-		else if( (totallba % 16) != 0 || ((totallba/16) % 63) != 0 )
+		else if( (totallba & 15) != 0 || ((totallba/16) % 63) != 0 )
 		{
 			log( -1, "'%s', file size does not match standard CHS geometry (x:16:63), please specify geometry explicitly with -g", name );
Index: /trunk/Serial_Server/win32/Win32.cpp
===================================================================
--- /trunk/Serial_Server/win32/Win32.cpp	(revision 591)
+++ /trunk/Serial_Server/win32/Win32.cpp	(revision 592)
@@ -37,5 +37,5 @@
 char *bannerStrings[] = {
 	"SerDrive - XTIDE Universal BIOS Serial Drive Server",
-	"Copyright (C) 2012-2013 by XTIDE Universal BIOS Team",
+	"Copyright (C) 2012-2018 by XTIDE Universal BIOS Team",
 	"Released under GNU GPL v2, with ABSOLUTELY NO WARRANTY",
 	ROM_VERSION_STRING,
@@ -49,6 +49,5 @@
  	"http://www.gnu.org/licenses/gpl-2.0.html",
 	"",
-	"Visit the wiki on http://code.google.com/p/xtideuniversalbios for detailed",
-	"serial drive usage directions.",
+	"Visit the wiki on http://xtideuniversalbios.org for detailed usage directions.",
 	"",
 	"Usage: SerDrive [options] imagefile [[slave-options] slave-imagefile]",
Index: /trunk/XTIDE_Universal_BIOS/Inc/BootVars.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/BootVars.inc	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS/Inc/BootVars.inc	(revision 592)
@@ -28,6 +28,4 @@
 ; Number of times to retry booting before accepting error
 BOOT_READ_RETRY_TIMES		EQU		3
-
-
 
 ; Pre-boot variables. These do not exist after successful boot to OS.
@@ -69,4 +67,7 @@
 %endif ; MODULE_HOTKEYS
 
+; MAX_HARD_DISK_NAME_LENGTH must be defined ahead of the DRVDETECTINFO structure to avoid problems with NASM
+MAX_HARD_DISK_NAME_LENGTH	EQU		30		; Bytes reserved for drive name
+
 struc DRVDETECTINFO
 	.StartOfDrvDetectInfo:
@@ -79,24 +80,10 @@
 endstruc
 
-; Boot Menu Information Table. These are generated for all XTIDE Universal
-; BIOS drives. Available only until boot is successful.
-MAX_HARD_DISK_NAME_LENGTH			EQU		30		; Bytes reserved for drive name
 DPT_DRVDETECTINFO_SIZE_MULTIPLIER	EQU		DRVDETECTINFO_size / LARGEST_DPT_SIZE
 
-
 %ifndef CHECK_FOR_UNUSED_ENTRYPOINTS
-
 %if MAX_HARD_DISK_NAME_LENGTH % 2 <> 0
 	%error "MAX_HARD_DISK_NAME_LENGTH needs to be a multiple of 2, memory is moved with word operations."
 %endif
-
-%if DRVDETECTINFO_size % LARGEST_DPT_SIZE <> 0
-	%error "DRVDETECTINFO's size must be an even multiple of DPT's size.  Add or remove padding at the bottom of DRVDETECTINFO to bring the two sizes into alignment.  As DRVDETECTINFO is only used at boot time, with plenty of memory to consume, it is OK to waste some space here."
-%endif
-
-%if DRVDETECTINFO.szDrvName <> 0
-	%error "DRVDETECTINFO.szDrvName is assumed to be the first member of struc DRVDETECTINFO, in BootMenuPrint_RefreshItem"
-%endif
-
 %endif
 
Index: /trunk/XTIDE_Universal_BIOS/Inc/IdeIO.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/IdeIO.inc	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS/Inc/IdeIO.inc	(revision 592)
@@ -57,8 +57,8 @@
 %ifndef MODULE_8BIT_IDE	; Standard IDE controllers only
 
+	eMOVZX	bx, [di+DPT.bIdevarsOffset]
 	%ifnidni %1, dx
 		mov		dx, %1
 	%endif
-	eMOVZX	bx, BYTE [di+DPT.bIdevarsOffset]
 	add		dx, [cs:bx+IDEVARS.wControlBlockPort]
 	out		dx, al
Index: /trunk/XTIDE_Universal_BIOS/Inc/RomVars.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/RomVars.inc	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS/Inc/RomVars.inc	(revision 592)
@@ -35,4 +35,5 @@
 	.wDisplayMode		resb	2	; Display mode for boot menu
 	.wBootTimeout		resb	2	; Boot Menu selection timeout in system timer ticks
+	.pColorTheme		resb	2	; Ptr to the color attribute struc used by the boot menu and hotkey bar
 	.bIdeCnt			resb	1	; Number of available IDE controllers
 	.bBootDrv			resb	1	; Default drive to boot from
@@ -182,5 +183,5 @@
 endstruc
 
-; Bit defines for DRVPARAMS.wFlags
+; Bit defines for DRVPARAMS.wFlags - these flags are accessed as bytes so changes here might require changes elsewhere
 MASK_DRVPARAMS_WRITECACHE		EQU	(3<<0)	; Bits 0...1, Drive internal write cache settings (must start at bit 0)
 	DEFAULT_WRITE_CACHE				EQU	0	; Must be 0
Index: /trunk/XTIDE_Universal_BIOS/Inc/Version.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/Version.inc	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS/Inc/Version.inc	(revision 592)
@@ -20,4 +20,5 @@
 
 ; Flash signature revisions:
+; XTIDE206	Added support for Color Themes
 ; XTIDE205	Added DEVICE_8BIT_XTCF_PIO16_WITH_BIU_OFFLOAD after other XT-CF
 ;			PIO modes (prevents empty indexes in PIO jump tables)
@@ -48,5 +49,5 @@
 %define	TITLE_STRING			TITLE_STRING_START, TITLE_STRING_END
 %define	ROM_VERSION_STRING		"v2.0.0",BETA,"3+ (",__DATE__,")",NULL
-%define	FLASH_SIGNATURE			"XTIDE205"	; Do not terminate with NULL
+%define	FLASH_SIGNATURE			"XTIDE206"	; Do not terminate with NULL
 
 
Index: /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeCommand.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeCommand.asm	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeCommand.asm	(revision 592)
@@ -200,8 +200,12 @@
 %ifdef MODULE_IRQ
 	test	BYTE [bp+IDEPACK.bDeviceControl], FLG_DEVCONTROL_nIEN
+%ifdef USE_386
+	jnz		IdeWait_IRQorStatusFlagInBLwithTimeoutInBH
+%else
 	jz		SHORT .PollStatusFlagInsteadOfWaitIrq
 	jmp		IdeWait_IRQorStatusFlagInBLwithTimeoutInBH
 .PollStatusFlagInsteadOfWaitIrq:
 %endif
+%endif ; MODULE_IRQ
 	jmp		IdeWait_PollStatusFlagInBLwithTimeoutInBH
 
Index: /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeDPT.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeDPT.asm	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeDPT.asm	(revision 592)
@@ -121,5 +121,5 @@
 	jnz		SHORT .ChangeTo32bitDevice
 
-	and		BYTE [di+DPT.bFlagsHigh], ~FLGH_DPT_IORDY	; No IORDY supported if need to limit
+	and		[di+DPT.bFlagsHigh], ah		; Mask off FLGH_DPT_IORDY if IORDY not supported
 	MIN_U	[di+DPT_ADVANCED_ATA.bPioMode], al
 	mov		[di+DPT_ADVANCED_ATA.wMinPioCycleTime], bx
Index: /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/JrIdeTransfer.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/JrIdeTransfer.asm	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS/Src/Device/IDE/JrIdeTransfer.asm	(revision 592)
@@ -147,5 +147,5 @@
 	lds		di, [bp+MEMPIOVARS.fpDPT]			; DPT now in DS:DI
 %ifdef USE_386
-	movzx	cx, BYTE [bp+MEMPIOVARS.bSectorsDone]
+	movzx	cx, [bp+MEMPIOVARS.bSectorsDone]
 %else
 	mov		ch, 0								; Preserve CF
